package com.actuate.activeportal.actions;

import com.actuate.activeportal.beans.*;
import com.actuate.activeportal.control.*;
import com.actuate.activeportal.forms.JobActionForm;
import com.actuate.activeportal.forms.QueryActionForm;
import com.actuate.activeportal.idapiadapter.*;
import com.actuate.reportcast.utils.*;
import com.actuate.reportcast.utils.beans.message.MessageItem;
import com.actuate.schemas.*;
import java.io.IOException;
import java.text.Format;
import java.text.MessageFormat;
import java.util.*;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.http.*;
import javax.swing.tree.TreeNode;
import org.apache.struts.action.*;
import org.apache.struts.util.MessageResources;

// Referenced classes of package com.actuate.activeportal.actions:
//            AcJobAction, AcBaseAction

public class AcCreateQueryAction extends AcJobAction
    implements ILabelProvider
{

    public AcCreateQueryAction()
    {
        CREATEQUERYBEAN_KEY = "createQueryBean";
    }

    public ActionForward perform(ActionMapping actionmapping, ActionForm actionform, HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse)
        throws IOException, ServletException
    {
        AcRequestHandlerBean acrequesthandlerbean;
        MessageItem messageitem;
        UserInfoBean userinfobean;
        QueryActionForm queryactionform;
        CreateQueryBean createquerybean;
        boolean flag;
label0:
        {
            acrequesthandlerbean = new AcRequestHandlerBean();
            acrequesthandlerbean.setRequest(httpservletrequest);
            messageitem = null;
            String s = commonActionOperations(acrequesthandlerbean, httpservletresponse);
            if(s != null)
                return actionmapping.findForward(s);
            HttpSession httpsession = httpservletrequest.getSession();
            userinfobean = acrequesthandlerbean.getUserInfoBeanFromSession();
            queryactionform = (QueryActionForm)actionform;
            createquerybean = (CreateQueryBean)httpsession.getAttribute(CREATEQUERYBEAN_KEY);
            queryactionform.setNotificationSupported(userinfobean.getFeatureOptionsBean().isSelfNotificationWithAttachmentSubfeature());
            if(StaticFuncs.getApplicationType() == 1)
                queryactionform.setNotificationSupported(true);
            flag = null != acrequesthandlerbean.getParameterFromHttpRequest("run", null) || null != acrequesthandlerbean.getParameterFromHttpRequest("preview", null);
            if(null != acrequesthandlerbean.getParameterFromHttpRequest("cancel", null))
            {
                httpsession.removeAttribute(CREATEQUERYBEAN_KEY);
                return actionmapping.findForward("cancel");
            }
            if(createquerybean != null)
                if(null != acrequesthandlerbean.getParameterFromHttpRequest("back", null))
                {
                    String as[] = createquerybean.getDisplayedTabs();
                    commandBack(queryactionform, as);
                } else
                if(null != acrequesthandlerbean.getParameterFromHttpRequest("next", null))
                {
                    String as1[] = createquerybean.getDisplayedTabs();
                    commandNext(queryactionform, as1);
                } else
                if(null != acrequesthandlerbean.getParameterFromHttpRequest("finish", null))
                    commandFinish(queryactionform);
            queryactionform.fixUTF8();
            fixParameters(queryactionform, acrequesthandlerbean, createquerybean);
            String s1 = queryactionform.getDataSourceName();
            String s2 = queryactionform.getDataSourceId();
            if((s1 == null || s1.trim().length() == 0) && (s2 == null || s2.trim().length() == 0))
                s1 = acrequesthandlerbean.getParameterFromHttpRequest("__executableName", null);
            if(isNewQuery(s2, s1, createquerybean, false))
                createquerybean = null;
            messageitem = validateRequest(createquerybean, s1, s2);
            if(messageitem != null)
            {
                httpservletrequest.setAttribute("__ERROR__MESSAGE", messageitem);
                return actionmapping.findForward("error");
            }
            if(null == createquerybean)
            {
                messageitem = getQuery(httpsession, acrequesthandlerbean, s1, s2, null, false, false);
                if(null != messageitem)
                {
                    httpservletrequest.setAttribute("__ERROR__MESSAGE", messageitem);
                    String s3 = httpservletrequest.getContextPath() + "/private/query/close.jsp";
                    messageitem.setRedirectURL(s3);
                    return actionmapping.findForward("error");
                }
                createquerybean = (CreateQueryBean)httpsession.getAttribute(CREATEQUERYBEAN_KEY);
                createquerybean.setViewInNewWindow(queryactionform.getViewInNewWindow());
                if(null == createquerybean)
                    throw new ServletException("GetQuery failed " + s1);
            }
            httpservletrequest.setAttribute("columnFilters", createquerybean.getColumnFilters());
            httpservletrequest.setAttribute("queryForm", queryactionform);
            setPageTitle(httpservletrequest, createquerybean, userinfobean.getLocale());
            if(isTokenValid(httpservletrequest))
            {
                messageitem = saveTab(queryactionform, createquerybean);
                if(null != messageitem)
                    break label0;
            }
            saveToken(httpservletrequest);
        }
        boolean flag1 = null != acrequesthandlerbean.getParameterFromHttpRequest("save", null);
        boolean flag2 = "true".equalsIgnoreCase(queryactionform.getQueryOverwrite());
        if(flag2)
            flag1 = true;
        if(flag1 || flag2)
        {
            messageitem = validateQuery(createquerybean);
            if(messageitem == null)
            {
                String s4 = createquerybean.getSaveName();
                double d = Math.sqrt(s4.length());
                int i = 200 + s4.length() * 8;
                if(i > 640)
                    i = 640;
                int j = (int)(90D + 0.86599999999999999D * d * 8D);
                String s5 = "AcConfirmationForJSP" + String.valueOf(Math.abs(httpservletrequest.getSession().getId().hashCode()));
                if(!flag2 && isEncyclopediaFileExists(s4, acrequesthandlerbean))
                {
                    String s6 = createURL(actionmapping, httpservletrequest, httpservletresponse, "overwritePrompt", userinfobean.getMultivolumeParameter());
                    openPopupWindow(httpservletrequest, s6, s5, String.valueOf(i), String.valueOf(j), "resizable=yes,scrollbars=yes,menubar=no");
                    flag1 = false;
                }
                if(flag1)
                {
                    messageitem = saveQuery(createquerybean, acrequesthandlerbean);
                    if(null == messageitem)
                    {
                        String s7 = createURL(actionmapping, httpservletrequest, httpservletresponse, "confirmation", userinfobean.getMultivolumeParameter());
                        openPopupWindow(httpservletrequest, s7, s5, String.valueOf(i), String.valueOf(j), "resizable=yes,scrollbars=yes,menubar=no");
                    }
                }
            }
        }
        if(flag)
        {
            messageitem = validateParameters(acrequesthandlerbean, createquerybean.getParameterDefinitions(), createquerybean.getParameters());
            messageitem = validateQuery(createquerybean);
            if(messageitem == null)
            {
                boolean flag3 = null == messageitem && createquerybean.getSelectedColumns().size() > 0;
                if(flag3)
                    messageitem = commandExecuteQuery(httpservletrequest, httpservletresponse, createquerybean, acrequesthandlerbean, true);
            }
        }
        queryactionform.setSortNewColumn("");
        queryactionform.setFilterNewColumn("");
        loadTab(queryactionform, createquerybean, httpservletrequest, userinfobean);
        queryactionform.setSaveTab(queryactionform.getLoadTab());
        if(null != messageitem)
        {
            httpservletrequest.setAttribute("__ERROR__MESSAGE", messageitem);
            messageitem.setStayInThisPage(true);
            return new ActionForward(actionmapping.getInput());
        } else
        {
            return actionmapping.findForward("success");
        }
    }

    protected MessageItem validateQuery(CreateQueryBean createquerybean)
    {
        Vector vector = createquerybean.getColumnsAvailableToGroup();
        if(vector == null || vector.size() == 0)
        {
            MessageItem messageitem = new MessageItem();
            messageitem.setKey("query.create.noDetail");
            return messageitem;
        } else
        {
            return null;
        }
    }

    protected static String createURL(ActionMapping actionmapping, HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse, String s, String s1)
    {
        ActionForward actionforward = actionmapping.findForward(s);
        String s2 = httpservletrequest.getContextPath() + actionforward.getPath();
        if(null != s1 && 0 < s1.length())
            s2 = StaticFuncs.appendRequiredDataToBasePath(s2) + s1;
        return httpservletresponse.encodeURL(s2);
    }

    protected static boolean isNewQuery(String s, String s1, CreateQueryBean createquerybean, boolean flag)
    {
        return null != s || null != s1;
    }

    protected MessageItem commandExecuteQuery(HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse, CreateQueryBean createquerybean, AcRequestHandlerBean acrequesthandlerbean, boolean flag)
    {
        AcExecuteQueryAdapter acexecutequeryadapter = executeQuery(createquerybean, acrequesthandlerbean, flag);
        MessageItem messageitem = acexecutequeryadapter.getErrorObj();
        if(null == messageitem)
        {
            String s = acexecutequeryadapter.getStatus();
            if("failed".equalsIgnoreCase(s))
            {
                messageitem = new MessageItem();
                messageitem.setKey("EXECUTE_REPORT_FAILED");
                messageitem.setMessage(acexecutequeryadapter.getErrorDescription());
            } else
            {
                String s1 = createquerybean.getOutputFormat();
                if("XLS".equalsIgnoreCase(s1))
                    s1 = "ExcelDataDump";
                String s2 = "";
                String s4 = "true";
                String s5 = "resizable=yes,scrollbars=yes";
                String s3;
                if("EANALYSIS".equalsIgnoreCase(s1))
                {
                    s3 = "/servlet/DownloadSearchResult";
                    s1 = "analysis";
                } else
                if("ExcelDataDump".equalsIgnoreCase(s1) || "PDF".equalsIgnoreCase(s1))
                {
                    s3 = "/servlet/GetReportData";
                    s5 = s5 + ",menubar=yes";
                } else
                if(!"DHTML".equalsIgnoreCase(s1))
                {
                    s3 = "/servlet/ViewPage";
                } else
                {
                    s3 = "/viewer/viewframeset.jsp";
                    s4 = "true";
                }
                if("pending".equalsIgnoreCase(s))
                    s2 = s2 + "/private/newrequest/waitforexecution.jsp";
                else
                    s2 = s2 + s3;
                String s6 = createquerybean.getQueryName();
                if(!s6.endsWith(".dov"))
                    s6 = s6 + ".dov";
                if(acexecutequeryadapter.isSaveOutputFile())
                    s6 = createquerybean.getDocumentName();
                s2 = s2 + "?id=" + acexecutequeryadapter.getObjectId() + "&connectionhandle=" + StaticFuncs.encode(acexecutequeryadapter.getConnectionHandle()) + "&format=" + s1 + "&outputname=" + StaticFuncs.encode(s6) + "&saveOutput=" + acexecutequeryadapter.isSaveOutputFile() + "&location=" + s3 + "&openViewer=" + s4;
                if("true".equalsIgnoreCase(s4))
                {
                    if(acexecutequeryadapter.getExecutableFileId() != null && acexecutequeryadapter.getExecutableFileId().trim().length() > 0)
                        s2 = s2 + "&__executableid=" + acexecutequeryadapter.getExecutableFileId().trim();
                    s2 = s2 + "&__executablename=" + StaticFuncs.encode(createquerybean.getDataSourceName());
                }
                s2 = s2 + "&closeX=true";
                s2 = s2 + "&" + acrequesthandlerbean.getUserInfoBeanFromSession().getMultivolumeParameter();
                String s7 = httpservletresponse.encodeURL(httpservletrequest.getContextPath() + s2);
                if(createquerybean.getViewInNewWindow())
                {
                    String s8 = "AcQueryPreview" + String.valueOf(Math.abs(httpservletrequest.getSession().getId().hashCode()));
                    openPopupWindow(httpservletrequest, s7, s8, "800", "600", s5);
                } else
                {
                    httpservletrequest.setAttribute("javaScriptCommands", "<Script>window.location.replace(\"" + s7 + "\");</Script>");
                    httpservletrequest.setAttribute("forwardLocation", s2);
                }
            }
        }
        return messageitem;
    }

    public static void openPopupWindow(HttpServletRequest httpservletrequest, String s, String s1, String s2, String s3, String s4)
    {
        String s5 = mfPopupWindow.format(((Object) (new Object[] {
            StaticFuncs.jsEncode(s), StaticFuncs.jsEncode(s1), s2, s3, s4
        })));
        httpservletrequest.setAttribute("javaScriptCommands", s5);
    }

    protected boolean isEncyclopediaFileExists(String s, AcRequestHandlerBean acrequesthandlerbean)
    {
        AcGetFileDetailsAdapter2 acgetfiledetailsadapter2 = new AcGetFileDetailsAdapter2();
        acgetfiledetailsadapter2.setParameterHandler(acrequesthandlerbean);
        acgetfiledetailsadapter2.setFileName(s);
        acgetfiledetailsadapter2.execute();
        return null != acgetfiledetailsadapter2.getFile();
    }

    protected void fixParameters(QueryActionForm queryactionform, AcRequestHandlerBean acrequesthandlerbean, CreateQueryBean createquerybean)
    {
        queryactionform.setDataSourceName(acrequesthandlerbean.getParameterFromHttpRequest("__executableName", queryactionform.getDataSourceName()));
        queryactionform.setDataSourceName(acrequesthandlerbean.getParameterFromHttpRequest("__executableFileName", queryactionform.getDataSourceName()));
        queryactionform.setDataSourceId(acrequesthandlerbean.getParameterFromHttpRequest("__executableId", queryactionform.getDataSourceId()));
        if(null == createquerybean)
            queryactionform.setDataSourceName(acrequesthandlerbean.getParameterFromHttpRequest("executableName", queryactionform.getDataSourceName()));
    }

    protected MessageItem getQuery(HttpSession httpsession, AcRequestHandlerBean acrequesthandlerbean, String s, String s1, String s2, boolean flag, boolean flag1)
    {
        MessageItem messageitem = null;
        AcGetQueryAdapter acgetqueryadapter = new AcGetQueryAdapter();
        AcGetFileDetailsAdapter2 acgetfiledetailsadapter2 = new AcGetFileDetailsAdapter2();
        if(null == s1)
        {
            acgetqueryadapter.setQueryFileName(s);
            acgetfiledetailsadapter2.setFileName(s);
        } else
        {
            acgetqueryadapter.setQueryFileId(s1);
            acgetfiledetailsadapter2.setFileId(s1);
        }
        acgetfiledetailsadapter2.setParameterHandler(acrequesthandlerbean);
        acgetfiledetailsadapter2.execute();
        s = acgetfiledetailsadapter2.getFileName();
        acgetqueryadapter.setParameterHandler(acrequesthandlerbean);
        acgetqueryadapter.getRequest().setGroupingEnabled(Boolean.TRUE);
        acgetqueryadapter.execute();
        messageitem = acgetqueryadapter.getErrorObj();
        Query query = acgetqueryadapter.getQuery();
        if(null == messageitem && (null == query || null != query && null == query.getAvailableColumnList()))
        {
            messageitem = new MessageItem();
            messageitem.setKey("error.query.empty");
            messageitem.addArgument(s);
            return messageitem;
        }
        if(null == messageitem)
        {
            CreateQueryBean createquerybean = new CreateQueryBean();
            createquerybean.setForRunning(flag1);
            createquerybean.setDataSourceName(s);
            createquerybean.setSubmitQuery(flag);
            UserInfoBean userinfobean = acrequesthandlerbean.getUserInfoBeanFromSession();
            // DJM 3/4/04: Set locale in createquerybean for external column label database lookup
			String newLocaleID = (String) acrequesthandlerbean.getRequest().getSession().getAttribute("mroLangCode");
            createquerybean.setLocaleID(newLocaleID);
            createquerybean.setTimeZoneName(userinfobean.getTimezone().getID());
            TableParameterListBean tableparameterlistbean = (TableParameterListBean)acrequesthandlerbean.getRequest().getSession().getAttribute("com.actuate.beans.parameters.table.list");
            if(tableparameterlistbean == null)
            {
                tableparameterlistbean = new TableParameterListBean();
                acrequesthandlerbean.getRequest().getSession().setAttribute("com.actuate.beans.parameters.table.list", tableparameterlistbean);
            }
            createquerybean.setQueryDefinition(query, tableparameterlistbean);
            String s3 = StaticFuncs.stripFileExtension(s);
            s3 = StaticFuncs.stripFolderName(s3, "/").trim();
            String s4 = StaticFuncs.getFolderFromFilename(s);
            createquerybean.setQueryName(s3);
            createquerybean.setQueryLocation(s4);
            createquerybean.setDocumentName(s3);
            createquerybean.setDocumentLocation(s4);
            createquerybean.setJobName(s3);
            if(s.toLowerCase().endsWith(".dov"))
                createquerybean.setQueryDescription(acgetfiledetailsadapter2.getFile().getDescription());
            httpsession.setAttribute(CREATEQUERYBEAN_KEY, createquerybean);
        }
        return messageitem;
    }

    protected MessageItem saveQuery(CreateQueryBean createquerybean, AcRequestHandlerBean acrequesthandlerbean)
    {
        AcCreateQueryAdapter accreatequeryadapter = new AcCreateQueryAdapter();
        accreatequeryadapter.setParameterHandler(acrequesthandlerbean);
        accreatequeryadapter.setBasedOnFileName(createquerybean.getDataSourceName());
        accreatequeryadapter.setQuery(createquerybean.getUpdatedQuery(acrequesthandlerbean));
        NewFile newfile = createquerybean.getQueryFile();
        newfile.setName(createquerybean.getSaveName());
        accreatequeryadapter.setQueryFile(newfile);
        accreatequeryadapter.execute();
        return accreatequeryadapter.getErrorObj();
    }

    public static String createFileName(String s, String s1)
    {
        if(s != null && s.length() > 0 && !s.endsWith("/"))
            s = s + "/";
        if(null == s)
            return s1;
        else
            return s + s1;
    }

    protected AcExecuteQueryAdapter executeQuery(CreateQueryBean createquerybean, AcRequestHandlerBean acrequesthandlerbean, boolean flag)
    {
        AcExecuteQueryAdapter acexecutequeryadapter = new AcExecuteQueryAdapter();
        acexecutequeryadapter.setInputFileName(createquerybean.getDataSourceName());
        if(flag)
            acexecutequeryadapter.setSaveOutputFile(false);
        else
            acexecutequeryadapter.setSaveOutputFile(createquerybean.isDocumentSave());
        if(acexecutequeryadapter.isSaveOutputFile())
        {
            NewFile newfile = createquerybean.getNewFile();
            newfile.setName(createquerybean.getNewFileName());
            acexecutequeryadapter.setRequestedOutputFile(newfile);
        }
        acexecutequeryadapter.setQuery(createquerybean.getUpdatedQuery(acrequesthandlerbean));
        acexecutequeryadapter.setProgressiveViewing(createquerybean.isProgressiveViewingLogic());
        acexecutequeryadapter.setParameterHandler(acrequesthandlerbean);
        acexecutequeryadapter.execute();
        return acexecutequeryadapter;
    }

    protected AcSubmitQueryAdapter submitQuery(CreateQueryBean createquerybean, AcRequestHandlerBean acrequesthandlerbean)
    {
        String s = createquerybean.getJobId();
        Object obj;
        if(null == s)
        {
            obj = new AcSubmitQueryAdapter();
        } else
        {
            obj = new AcUpdateScheduledQueryAdapter();
            ((AcSubmitQueryAdapter) (obj)).setJobId(s);
        }
        NewFile newfile = createquerybean.getNewFile();
        newfile.setName(createquerybean.getNewFileName());
        ((AcSubmitQueryAdapter) (obj)).setPriority(createquerybean.getPriority());
        ((AcSubmitQueryAdapter) (obj)).setJobName(createquerybean.getJobName());
        ((AcSubmitQueryAdapter) (obj)).setInputFileName(createquerybean.getDataSourceName());
        ((AcSubmitQueryAdapter) (obj)).setRequestedOutputFile(newfile);
        ArrayOfFilterCriteria arrayoffiltercriteria = null;
        Query query = createquerybean.getQuery();
        if(query != null)
            arrayoffiltercriteria = query.getFilterList();
        if(arrayoffiltercriteria != null)
            arrayoffiltercriteria.setFilterCriteria(createquerybean.getFilters());
        ((AcSubmitQueryAdapter) (obj)).setQuery(createquerybean.getUpdatedQuery(acrequesthandlerbean));
        ((AcSubmitQueryAdapter) (obj)).setNotifyChannelsByName(createquerybean.getNotifyChannelsByName());
        ((AcSubmitQueryAdapter) (obj)).setNotifyGroupsByName(createquerybean.getNotifyGroupsByName());
        ((AcSubmitQueryAdapter) (obj)).setNotifyUsersByName(createquerybean.getNotifyUsersByName());
        UserInfoBean userinfobean = acrequesthandlerbean.getUserInfoBeanFromSession();
        ((AcSubmitJobAdapter) (obj)).setLocale(userinfobean.getAcLocale());
        ((AcSubmitJobAdapter) (obj)).setDatePattern(userinfobean.getAcLocale().getDatePattern(3));
        ((AcSubmitJobAdapter) (obj)).setTimePattern(userinfobean.getAcLocale().getTimePattern(3));
        ((AcSubmitQueryAdapter) (obj)).setTimeZoneName(createquerybean.getTimeZoneName());
        ((AcSubmitQueryAdapter) (obj)).setScheduleType(createquerybean.getScheduleType());
        ((AcSubmitQueryAdapter) (obj)).setOnceDate(createquerybean.getOnceDate());
        ((AcSubmitQueryAdapter) (obj)).setOnceTime(createquerybean.getOnceTime());
        ((AcSubmitQueryAdapter) (obj)).setRecurringDay(createquerybean.getRecurringDay());
        ((AcSubmitQueryAdapter) (obj)).setRecurringTime(createquerybean.getRecurringTime());
        ((AcSubmitQueryAdapter) (obj)).setStartDate(createquerybean.isUseStartDateTime() ? createquerybean.getStartDate() : null);
        ((AcSubmitQueryAdapter) (obj)).setEndDate(createquerybean.isUseEndDateTime() ? createquerybean.getEndDate() : null);
        ((AcBaseAdapter) (obj)).setParameterHandler(acrequesthandlerbean);
        ((AcSubmitQueryAdapter) (obj)).setNotify(createquerybean.isNotify());
        String s1 = createquerybean.getNotificationAttachment();
        if("excel".equals(s1.trim().toLowerCase()))
            s1 = "ExcelData";
        ((AcSubmitQueryAdapter) (obj)).setNotificationAttachment(s1);
        ((AcBaseAdapter) (obj)).execute();
        return ((AcSubmitQueryAdapter) (obj));
    }

    protected int getTabIndex(String s)
    {
        for(int i = 0; i < TABNAME_KEYS.length; i++)
            if(TABNAME_KEYS[i].equals(s))
                return i;

        return 0;
    }

    protected static void commandBack(QueryActionForm queryactionform, String as[])
    {
        int i = 0;
        String s = queryactionform.getLoadTab();
        for(int j = i + 1; j < as.length; j++)
            if(as[j].equals(s))
                queryactionform.setLoadTab(as[j - 1]);

    }

    protected static void commandNext(QueryActionForm queryactionform, String as[])
    {
        int i = as.length - 1;
        String s = queryactionform.getLoadTab();
        for(int j = 0; j + 1 < as.length; j++)
            if(as[j].equals(s))
                queryactionform.setLoadTab(as[j + 1]);

    }

    protected void commandFinish(QueryActionForm queryactionform)
    {
        queryactionform.setLoadTab(TABNAME_KEYS[TABNAME_KEYS.length - 1]);
    }

    protected MessageItem saveTab(QueryActionForm queryactionform, CreateQueryBean createquerybean)
    {
        MessageItem messageitem = null;
        String s = queryactionform.getSaveTab();
        boolean flag = Boolean.TRUE == queryactionform.getHidePrompt();
        if("schedule".equals(s))
        {
            createquerybean.setJobName(queryactionform.getJobName());
            createquerybean.setScheduleType(queryactionform.getScheduleType());
            createquerybean.setOnceDate(queryactionform.getOnceDate());
            createquerybean.setOnceTime(queryactionform.getOnceTime());
            createquerybean.setRecurringDay(queryactionform.getRecurringDay());
            createquerybean.setRecurringTime(queryactionform.getRecurringTime());
            createquerybean.setUseStartDateTime(queryactionform.isUseStartDateTime());
            createquerybean.setUseEndDateTime(queryactionform.isUseEndDateTime());
            createquerybean.setStartDate(queryactionform.getStartDate());
            createquerybean.setEndDate(queryactionform.getEndDate());
        } else
        if("content".equals(s))
        {
            createquerybean.setSelectedColumnAsString(queryactionform.getSelectedColumns());
            createquerybean.refreshGroups();
            createquerybean.refreshSummaryColumns();
            createquerybean.refreshSortColumns();
            if(!flag)
                createquerybean.setPromptSelectColumnList(queryactionform.isContentPrompt());
        } else
        if("groups".equals(s))
        {
            HtmlTree htmltree = createquerybean.getGroups();
            if(queryactionform.getSelectedNode() != null && queryactionform.getSelectedNode().trim().length() > 0 && !queryactionform.getSelectedNode().equals(queryactionform.getLastSelectedNode()))
            {
                HtmlTreeNode htmltreenode = htmltree.find(queryactionform.getSelectedNode());
                if(htmltreenode != null)
                    createquerybean.setSelectedNode(htmltreenode);
                htmltreenode = htmltree.find(queryactionform.getLastSelectedNode());
                if(htmltreenode != null)
                    htmltreenode.setSelected(false);
            }
            if(!flag)
                createquerybean.setAllowGroupingChangeAtRuntime(queryactionform.isAllowGroupingChangeAtRuntime());
            if("toggle".equals(queryactionform.getTreeCommand()))
            {
                HtmlTreeNode htmltreenode1 = htmltree.find(queryactionform.getTreePath());
                htmltreenode1.setOpened(!htmltreenode1.isOpened());
            } else
            if("removeSelected".equals(queryactionform.getTreeCommand()))
            {
                HtmlTreeNode htmltreenode2 = createquerybean.getSelectedNode();
                if(htmltreenode2 != null)
                {
                    HtmlTreeNode htmltreenode5 = htmltreenode2.getParentNode();
                    if(htmltreenode5 != null)
                    {
                        htmltreenode2.setSelected(false);
                        int i = htmltreenode5.getIndex(htmltreenode2);
                        htmltreenode5.removeChild(htmltreenode2);
                        createquerybean.setSelectedNode(null);
                        if(htmltreenode5.getChildCount() == 0)
                        {
                            htmltreenode5.setExpandable(false);
                            createquerybean.setSelectedNode(htmltreenode5);
                        } else
                        {
                            if(i >= htmltreenode5.getChildCount())
                                i = htmltreenode5.getChildCount() - 1;
                            createquerybean.setSelectedNode((HtmlTreeNode)htmltreenode5.getChildList().get(i));
                        }
                    }
                    createquerybean.refreshSummaryColumns();
                    createquerybean.refreshSortColumns();
                }
            } else
            if("moveSelectedUp".equals(queryactionform.getTreeCommand()))
            {
                HtmlTreeNode htmltreenode3 = createquerybean.getSelectedNode();
                if(htmltreenode3 != null)
                {
                    HtmlTreeNode htmltreenode6 = htmltreenode3.getParentNode();
                    if(htmltreenode6 != null && !htmltreenode6.moveUp(htmltreenode3))
                    {
                        HtmlTreeNode htmltreenode8 = htmltreenode6.getPreviousSibling();
                        if(htmltreenode8 != null)
                        {
                            htmltreenode6.removeChild(htmltreenode3);
                            if(htmltreenode6.getChildCount() == 0)
                                htmltreenode6.setExpandable(false);
                            if(htmltreenode8.getChildCount() == 0)
                            {
                                htmltreenode8.setExpandable(true);
                                htmltreenode8.setOpened(true);
                            }
                            htmltreenode8.addChild(htmltreenode3);
                        }
                    }
                }
            } else
            if("moveSelectedDown".equals(queryactionform.getTreeCommand()))
            {
                HtmlTreeNode htmltreenode4 = createquerybean.getSelectedNode();
                if(htmltreenode4 != null)
                {
                    HtmlTreeNode htmltreenode7 = htmltreenode4.getParentNode();
                    if(htmltreenode7 != null && !htmltreenode7.moveDown(htmltreenode4))
                    {
                        HtmlTreeNode htmltreenode9 = htmltreenode7.getNextSibling();
                        if(htmltreenode9 != null)
                        {
                            htmltreenode7.removeChild(htmltreenode4);
                            if(htmltreenode7.getChildCount() == 0)
                                htmltreenode7.setExpandable(false);
                            if(htmltreenode9.getChildCount() == 0)
                            {
                                htmltreenode9.setExpandable(true);
                                htmltreenode9.setOpened(true);
                            }
                            htmltreenode9.insertChildAfter(-1, htmltreenode4);
                        }
                    }
                }
            } else
            if("addToSelectedNode".equals(queryactionform.getTreeCommand()) && queryactionform.getAddToGroups() != null && queryactionform.getAddToGroups().length > 0)
            {
                createquerybean.addGroup(queryactionform.getAddToGroups());
                queryactionform.setAddToGroups(null);
                createquerybean.refreshSummaryColumns();
                createquerybean.refreshSortColumns();
            }
            queryactionform.setTreeCommand(null);
            queryactionform.setTreePath(null);
        } else
        if("summary".equals(s))
        {
            createquerybean.updateSummaryColumns(queryactionform.getSummaryColumns());
            if(!flag)
                createquerybean.setAllowSummaryChangeAtRuntime(queryactionform.isAllowSummaryChangeAtRuntime());
            createquerybean.setShowRowCountsInTotal(queryactionform.isShowRowCountsInTotal());
        } else
        if("sorting".equals(s))
        {
            if(!flag)
                createquerybean.setPromptSortColumnList(queryactionform.isSortPrompt());
            createquerybean.setSortNameOrder(queryactionform.getName(), queryactionform.getSortOrder());
            createquerybean.updateGroupSortOrder(queryactionform.getGroupNodes());
            String s1 = queryactionform.getSortNewColumn();
            if(null != s1 && s1.trim().length() > 0)
                createquerybean.newSortColumn(s1, queryactionform.getSortNewSortOrder());
        } else
        if("filters".equals(s))
        {
            createquerybean.setParameters(queryactionform.getParameters(), queryactionform.getHidePrompt());
            createquerybean.setFilters(queryactionform.getFilters(), queryactionform.getHidePrompt());
            String s2 = queryactionform.getFilterNewColumn();
            if(null != s2 && s2.trim().length() > 0)
            {
                createquerybean.newFilterColumn(s2, queryactionform.getFilterNewOperator(), queryactionform.getFilterNewValue(), queryactionform.isFilterNewPrompt());
                queryactionform.setFilterNewOperator("=");
                queryactionform.setFilterNewValue("");
            }
        } else
        if("finish".equals(s))
        {
            createquerybean.setOutputFormat(queryactionform.getFormat());
            if(!flag)
                createquerybean.setPromptOutputFormat(queryactionform.isFormatPrompt());
            createquerybean.setQueryName(queryactionform.getQueryName());
            createquerybean.setQueryLocation(queryactionform.getQueryLocation());
            createquerybean.setQueryDescription(queryactionform.getDescription());
            createquerybean.setPageHeader(queryactionform.getPageHeader());
        } else
        if("run.finish".equals(s))
        {
            if(createquerybean.getQuery().getPromptOutputFormat() == Boolean.TRUE)
                createquerybean.setOutputFormat(queryactionform.getFormat());
            createquerybean.setDocumentSave(queryactionform.isDocumentSave());
            createquerybean.setDocumentName(queryactionform.getDocumentName());
            createquerybean.setDocumentVersionName(queryactionform.getDocumentVersionName());
            createquerybean.setDocumentOutputLocation(queryactionform.getDocumentOutputLocation());
            createquerybean.setDocumentLocation(queryactionform.getDocumentLocation());
            createquerybean.setNotify(queryactionform.isNotify());
            createquerybean.setNotificationAttachment(queryactionform.getNotificationAttachment());
            String s3 = queryactionform.getDocumentVersioning();
            if("replace".equalsIgnoreCase(s3))
                createquerybean.setDocumentReplaceExisting(true);
            else
                createquerybean.setDocumentReplaceExisting(false);
        }
        return messageitem;
    }

    protected void loadTab(QueryActionForm queryactionform, CreateQueryBean createquerybean, HttpServletRequest httpservletrequest, UserInfoBean userinfobean)
    {
        String s = queryactionform.getLoadTab();
        if("schedule".equals(s))
        {
            queryactionform.setJobName(createquerybean.getJobName());
            queryactionform.setScheduleType(createquerybean.getScheduleType());
            queryactionform.setOnceDate(createquerybean.getOnceDate());
            queryactionform.setOnceTime(createquerybean.getOnceTime());
            queryactionform.setRecurringDay(createquerybean.getRecurringDay());
            queryactionform.setRecurringTime(createquerybean.getRecurringTime());
            queryactionform.setUseStartDateTime(createquerybean.isUseStartDateTime());
            queryactionform.setUseEndDateTime(createquerybean.isUseEndDateTime());
            queryactionform.setStartDate(createquerybean.getStartDate());
            queryactionform.setEndDate(createquerybean.getEndDate());
        } else
        if("content".equals(s))
        {
            queryactionform.setContentPrompt(createquerybean.isPromptSelectColumnList());
            queryactionform.setSelectedColumns(createquerybean.getSelectedColumnsAsString());
        } else
        if("groups".equals(s))
        {
            HtmlTree htmltree = createquerybean.getGroups();
            HtmlTreeNode htmltreenode = htmltree.getRoot();
            if(htmltreenode.getName() == null || !htmltreenode.getName().equals("Groups--Root--Node"))
            {
                htmltreenode.setName("Groups--Root--Node");
                htmltreenode.setOpened(true);
                htmltreenode.setLabel(super.servlet.getResources().getMessage(userinfobean.getAcLocale().getJavaLocale(), "query.create.groups.label.tree.group"));
                String s2 = httpservletrequest.getContextPath() + "/";
                htmltree.prependImages(s2);
                htmltree.setSentinelRoot(false);
            }
            htmltree.setLabelProvider(this);
            if(createquerybean.getSelectedNode() == null)
            {
                htmltreenode.setSelected(true);
                createquerybean.setSelectedNode(htmltreenode);
            }
            queryactionform.setSelectedNode(createquerybean.getSelectedNode().getPath());
            queryactionform.setLastSelectedNode(queryactionform.getSelectedNode());
            queryactionform.setAllowGroupingChangeAtRuntime(createquerybean.isAllowGroupingChangeAtRuntime());
        } else
        if("summary".equals(s))
        {
            queryactionform.setSummaryColumns(createquerybean.getSummaryColumns());
            queryactionform.setAllowSummaryChangeAtRuntime(createquerybean.isAllowSummaryChangeAtRuntime());
            queryactionform.setShowRowCountsInTotal(createquerybean.isShowRowCountsInTotal());
        } else
        if("sorting".equals(s))
        {
            queryactionform.setSortPrompt(createquerybean.isPromptSortColumnList());
            httpservletrequest.setAttribute("sortColumns", createquerybean.getSortColumns());
            queryactionform.setGroupNodes(createquerybean.getGroups().getRoot().getChildList());
        } else
        if("filters".equals(s))
        {
            queryactionform.setParameters(createquerybean.getParameters());
            queryactionform.setFilters(createquerybean.getFilters());
            queryactionform.setFilterNewPrompt(true);
            httpservletrequest.setAttribute("com.actuate.query.filterOperators", createquerybean.getFilterOperators());
            httpservletrequest.setAttribute("parameterDefinitions", createquerybean.getParameterDefinitions());
            if(createquerybean.getColumnFilters().length > 0 && (!createquerybean.isForRunning() || queryactionform.getPromptedFilterCount().intValue() > 0))
                httpservletrequest.setAttribute("customFiltersAvailable", "true");
        } else
        if("finish".equals(s))
        {
            queryactionform.setFormat(createquerybean.getOutputFormat());
            queryactionform.setFormatPrompt(createquerybean.isPromptOutputFormat());
            queryactionform.setQueryName(createquerybean.getQueryName());
            queryactionform.setQueryLocation(createquerybean.getQueryLocation());
            queryactionform.setDescription(createquerybean.getQueryDescription());
            queryactionform.setPageHeader(createquerybean.getPageHeader());
            queryactionform.setQueryOverwrite("");
        } else
        if("run.finish".equals(s))
        {
            queryactionform.setFormat(createquerybean.getOutputFormat());
            queryactionform.setDocumentSave(createquerybean.isDocumentSave());
            queryactionform.setDocumentName(createquerybean.getDocumentName());
            queryactionform.setDocumentVersionName(createquerybean.getDocumentVersionName());
            queryactionform.setDocumentOutputLocation(createquerybean.getDocumentOutputLocation());
            queryactionform.setDocumentLocation(createquerybean.getDocumentLocation());
            String s1 = createquerybean.isDocumentReplaceExisting() ? "replace" : "create";
            queryactionform.setDocumentVersioning(s1);
            queryactionform.setNotify(createquerybean.isNotify());
            queryactionform.setNotificationAttachment(createquerybean.getNotificationAttachment());
            httpservletrequest.setAttribute("queryOutputFormat", getOutputFormatLabelKey(createquerybean.getOutputFormat()));
        }
        queryactionform.setSelectedColumnList(createquerybean.getSelectedColumns());
    }

    public static String getOutputFormatLabelKey(String s)
    {
        for(int i = 0; i < outputFormatLabels.length; i++)
            if(outputFormatLabels[i][0].equalsIgnoreCase(s))
                return outputFormatLabels[i][1];

        return "query.create.finish.label.format.DHTML";
    }

    private void setBreadCrumbs(Locale locale, ActionForm actionform, HttpServletRequest httpservletrequest)
    {
        MessageResources messageresources = super.servlet.getResources();
        String s = messageresources.getMessage(locale, "query.create.title");
        Vector vector = new Vector();
        vector.add(new LinkBean("", s));
        httpservletrequest.setAttribute("breadcrumbs", vector);
    }

    protected void setPageTitle(HttpServletRequest httpservletrequest, CreateQueryBean createquerybean, Locale locale)
    {
        String s = createquerybean.getDataSourceName();
        if(s != null && !s.trim().equals(""))
        {
            String s1 = StaticFuncs.getFileExtension(s);
            s = StaticFuncs.stripVersionNumber(s);
            String s2 = StaticFuncs.stripFileExtension(StaticFuncs.stripFolderName(s, "/"));
            MessageResources messageresources = super.servlet.getResources();
            String s3 = "query.create.title";
            if(createquerybean.isForRunning())
            {
                if(createquerybean.isSubmitQuery())
                    s3 = "query.submit.title";
                else
                    s3 = "query.run.title";
            } else
            if(s1 != null && s1.equalsIgnoreCase("dov"))
                s3 = "query.edit.title";
            String s4 = messageresources.getMessage(locale, s3);
            s4 = MessageFormat.format(s4, new Object[] {
                s2
            });
            httpservletrequest.setAttribute("TITLE", s4);
        }
    }

    protected MessageItem validateRequest(CreateQueryBean createquerybean, String s, String s1)
    {
        MessageItem messageitem = null;
        if(null == createquerybean && null == s && s1 == null)
        {
            messageitem = new MessageItem();
            messageitem.setMessage(super.servlet.getResources().getMessage("query.error.missing"));
        }
        return messageitem;
    }

    public String getLabel(Object obj, String s)
    {
        HtmlTreeNode htmltreenode = (HtmlTreeNode)obj;
        String s1 = "\t<TD id=\"cellLabel.{4}\" nowrap=nowrap {2}\n\t\tonClick=\"treeOnClick(''{1}'',this,''{3}'',event);\"\n\t\tondblClick=\"treeOnDoubleClick(''{1}'',this,''{3}'',event);\">{0}</TD>";
        MessageFormat messageformat = new MessageFormat(s1);
        StringBuffer stringbuffer = new StringBuffer();
        String s2 = null;
        if(s2 != null)
            stringbuffer.append("<img src=\"").append(s2).append("\" ").append("border=\"0\" ").append("/>");
        if(htmltreenode.getDepth() == 1)
        {
            String s3 = super.servlet.getResources().getMessage("query.create.groups.label.level", String.valueOf(htmltreenode.getParent().getIndex(htmltreenode) + 1));
            stringbuffer.append(s3);
        }
        stringbuffer.append(StaticFuncs.htmlEncode(htmltreenode.getLabel()));
        return messageformat.format(((Object) (new Object[] {
            stringbuffer.toString(), StaticFuncs.jsEncode(s), htmltreenode.isSelected() ? "class='treeControlSelectedItem'" : "class='treeControlItem'", StaticFuncs.jsEncode(htmltreenode.getName()), StaticFuncs.formValueEncode(s)
        })));
    }

    public static final String TABNAME_KEYS[] = {
        "content", "sorting", "filters", "finish"
    };
    public String CREATEQUERYBEAN_KEY;
    public static final String stringArray[] = new String[0];
    public static final String COLUMNFILTERS_KEY = "columnFilters";
    public static final String SORTCOLUMNS_KEY = "sortColumns";
    public static final String PARAMETERDEFINITIONS_KEY = "parameterDefinitions";
    public static final String QUERYFORM_KEY = "queryForm";
    public static final String JAVASCRIPT_KEY = "javaScriptCommands";
    public static final String FORWARDLOCATION_KEY = "forwardLocation";
    public static final String OUTPUTFORMATLABEL_KEY = "queryOutputFormat";
    private static final MessageFormat mfPopupWindow = new MessageFormat("\n<SCRIPT>\n\topenPopupWindow(''{0}'',''{1}'',{2},{3},''{4}'')</SCRIPT>\n");
    public static String outputFormatLabels[][] = {
        {
            "DHTML", "query.create.finish.label.format.DHTML"
        }, {
            "XLS", "query.create.finish.label.format.XLS"
        }, {
            "PDF", "query.create.finish.label.format.PDF"
        }, {
            "EANALYSIS", "query.create.finish.label.format.e.Analysis"
        }
    };

}